/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the Schedule type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Schedule{}

// Schedule struct for Schedule
type Schedule struct {
	// Action identifier
	ActionId interface{} `json:"action_id,omitempty"`
	// Timezone cron identifier
	Timezone *string `json:"timezone,omitempty"`
	// Minute cron identifier
	Minute interface{} `json:"minute,omitempty"`
	// Hour cron identifier
	Hour interface{} `json:"hour,omitempty"`
	// Day of month cron identifier
	DayOfMonth interface{} `json:"day_of_month,omitempty"`
	// Month cron identifier
	Month interface{} `json:"month,omitempty"`
	// Day of week cron identifier
	DayOfWeek interface{} `json:"day_of_week,omitempty"`
	// Sync frequency (day/week/month/custom)
	SyncFrequency interface{} `json:"sync_frequency,omitempty"`
}

// NewSchedule instantiates a new Schedule object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSchedule() *Schedule {
	this := Schedule{}
	return &this
}

// NewScheduleWithDefaults instantiates a new Schedule object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewScheduleWithDefaults() *Schedule {
	this := Schedule{}
	return &this
}

// GetActionId returns the ActionId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetActionId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ActionId
}

// GetActionIdOk returns a tuple with the ActionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetActionIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ActionId) {
		return nil, false
	}
	return &o.ActionId, true
}

// HasActionId returns a boolean if a field has been set.
func (o *Schedule) HasActionId() bool {
	if o != nil && IsNil(o.ActionId) {
		return true
	}

	return false
}

// SetActionId gets a reference to the given interface{} and assigns it to the ActionId field.
func (o *Schedule) SetActionId(v interface{}) {
	o.ActionId = v
}

// GetTimezone returns the Timezone field value if set, zero value otherwise.
func (o *Schedule) GetTimezone() string {
	if o == nil || IsNil(o.Timezone) {
		var ret string
		return ret
	}
	return *o.Timezone
}

// GetTimezoneOk returns a tuple with the Timezone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Schedule) GetTimezoneOk() (*string, bool) {
	if o == nil || IsNil(o.Timezone) {
		return nil, false
	}
	return o.Timezone, true
}

// HasTimezone returns a boolean if a field has been set.
func (o *Schedule) HasTimezone() bool {
	if o != nil && !IsNil(o.Timezone) {
		return true
	}

	return false
}

// SetTimezone gets a reference to the given string and assigns it to the Timezone field.
func (o *Schedule) SetTimezone(v string) {
	o.Timezone = &v
}

// GetMinute returns the Minute field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetMinute() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Minute
}

// GetMinuteOk returns a tuple with the Minute field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetMinuteOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Minute) {
		return nil, false
	}
	return &o.Minute, true
}

// HasMinute returns a boolean if a field has been set.
func (o *Schedule) HasMinute() bool {
	if o != nil && IsNil(o.Minute) {
		return true
	}

	return false
}

// SetMinute gets a reference to the given interface{} and assigns it to the Minute field.
func (o *Schedule) SetMinute(v interface{}) {
	o.Minute = v
}

// GetHour returns the Hour field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetHour() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Hour
}

// GetHourOk returns a tuple with the Hour field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetHourOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Hour) {
		return nil, false
	}
	return &o.Hour, true
}

// HasHour returns a boolean if a field has been set.
func (o *Schedule) HasHour() bool {
	if o != nil && IsNil(o.Hour) {
		return true
	}

	return false
}

// SetHour gets a reference to the given interface{} and assigns it to the Hour field.
func (o *Schedule) SetHour(v interface{}) {
	o.Hour = v
}

// GetDayOfMonth returns the DayOfMonth field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetDayOfMonth() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.DayOfMonth
}

// GetDayOfMonthOk returns a tuple with the DayOfMonth field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetDayOfMonthOk() (*interface{}, bool) {
	if o == nil || IsNil(o.DayOfMonth) {
		return nil, false
	}
	return &o.DayOfMonth, true
}

// HasDayOfMonth returns a boolean if a field has been set.
func (o *Schedule) HasDayOfMonth() bool {
	if o != nil && IsNil(o.DayOfMonth) {
		return true
	}

	return false
}

// SetDayOfMonth gets a reference to the given interface{} and assigns it to the DayOfMonth field.
func (o *Schedule) SetDayOfMonth(v interface{}) {
	o.DayOfMonth = v
}

// GetMonth returns the Month field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetMonth() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Month
}

// GetMonthOk returns a tuple with the Month field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetMonthOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Month) {
		return nil, false
	}
	return &o.Month, true
}

// HasMonth returns a boolean if a field has been set.
func (o *Schedule) HasMonth() bool {
	if o != nil && IsNil(o.Month) {
		return true
	}

	return false
}

// SetMonth gets a reference to the given interface{} and assigns it to the Month field.
func (o *Schedule) SetMonth(v interface{}) {
	o.Month = v
}

// GetDayOfWeek returns the DayOfWeek field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetDayOfWeek() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.DayOfWeek
}

// GetDayOfWeekOk returns a tuple with the DayOfWeek field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetDayOfWeekOk() (*interface{}, bool) {
	if o == nil || IsNil(o.DayOfWeek) {
		return nil, false
	}
	return &o.DayOfWeek, true
}

// HasDayOfWeek returns a boolean if a field has been set.
func (o *Schedule) HasDayOfWeek() bool {
	if o != nil && IsNil(o.DayOfWeek) {
		return true
	}

	return false
}

// SetDayOfWeek gets a reference to the given interface{} and assigns it to the DayOfWeek field.
func (o *Schedule) SetDayOfWeek(v interface{}) {
	o.DayOfWeek = v
}

// GetSyncFrequency returns the SyncFrequency field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Schedule) GetSyncFrequency() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.SyncFrequency
}

// GetSyncFrequencyOk returns a tuple with the SyncFrequency field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Schedule) GetSyncFrequencyOk() (*interface{}, bool) {
	if o == nil || IsNil(o.SyncFrequency) {
		return nil, false
	}
	return &o.SyncFrequency, true
}

// HasSyncFrequency returns a boolean if a field has been set.
func (o *Schedule) HasSyncFrequency() bool {
	if o != nil && IsNil(o.SyncFrequency) {
		return true
	}

	return false
}

// SetSyncFrequency gets a reference to the given interface{} and assigns it to the SyncFrequency field.
func (o *Schedule) SetSyncFrequency(v interface{}) {
	o.SyncFrequency = v
}

func (o Schedule) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Schedule) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.ActionId != nil {
		toSerialize["action_id"] = o.ActionId
	}
	if !IsNil(o.Timezone) {
		toSerialize["timezone"] = o.Timezone
	}
	if o.Minute != nil {
		toSerialize["minute"] = o.Minute
	}
	if o.Hour != nil {
		toSerialize["hour"] = o.Hour
	}
	if o.DayOfMonth != nil {
		toSerialize["day_of_month"] = o.DayOfMonth
	}
	if o.Month != nil {
		toSerialize["month"] = o.Month
	}
	if o.DayOfWeek != nil {
		toSerialize["day_of_week"] = o.DayOfWeek
	}
	if o.SyncFrequency != nil {
		toSerialize["sync_frequency"] = o.SyncFrequency
	}
	return toSerialize, nil
}

type NullableSchedule struct {
	value *Schedule
	isSet bool
}

func (v NullableSchedule) Get() *Schedule {
	return v.value
}

func (v *NullableSchedule) Set(val *Schedule) {
	v.value = val
	v.isSet = true
}

func (v NullableSchedule) IsSet() bool {
	return v.isSet
}

func (v *NullableSchedule) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSchedule(val *Schedule) *NullableSchedule {
	return &NullableSchedule{value: val, isSet: true}
}

func (v NullableSchedule) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSchedule) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
